;;****************************************************;;
;;        オフセット（線の端から部分線を出す）        ;;
;;                                           96/10/02 ;;
;;        OFF_4.LSP                                   ;;
;;                                                    ;;
;;****************************************************;;
(defun c:off_4( / ent0 pt ent pt_st pt_en s pt_hou dist1 dist2
                  ent1 n_pt_st n_pt_en)
(setvar "CMDECHO" 0)
;;線情報を得る-------------
	(setq ent0  (entsel "\nオフセットする線を指示："))
	(setq pt (cadr ent0))
	(setq ent (car ent0))
	(setq pt_st (cdr (assoc 10 (entget ent))))
	(setq pt_en (cdr (assoc 11 (entget ent))))
	(setq pt_st (trans pt_st 0 1))
	(setq pt_en (trans pt_en 0 1))
	(if (> (distance pt_st pt) (distance pt_en pt))
	    (setq s pt_st pt_st pt_en pt_en s)
	)
	(setq ang1  (angle pt_st pt_en))
;;線の方向と長さを問う-----------
	(setq pt_hou (getpoint "\nオフセットする方向を指示："))
	(setq dist1  (getdist  "\nオフセットの間隔は？"))
	(setq dist2  (getreal  "\n線の長さは？"))
;;オフセットした線の情報を得て、描き直す
	(command "OFFSET" dist1 ent0 pt_hou "")
	(setq ent1 (entlast))
	(setq n_pt_st (cdr (assoc 10 (entget ent1))))
	(setq n_pt_en (cdr (assoc 11 (entget ent1))))
	(setq n_pt_st (trans n_pt_st 0 1))
	(setq n_pt_en (trans n_pt_en 0 1))
	(if (> (distance pt_st n_pt_st) (distance pt_st n_pt_en))
	    (setq s n_pt_st n_pt_st n_pt_en n_pt_en s)
	)
	(command "ERASE" ent1 "")
	(command "LINE" n_pt_st (polar n_pt_st ang1 dist2) "")
(redraw)
(setvar "CMDECHO" 1)
(princ)
)
