;;**********************************************************;;
;;     フックのない引き出し線                               ;;
;;                                                          ;;
;;     sun_hiki.lsp                                         ;;
;;                                                          ;;
;;                                       98/01/12           ;;
;;**********************************************************;;
(defun C:sun_hiki( / var_txt var_scal var_gap moji_taka moji_gap
                    pt_1 pt_2 ang_1 ent_1 str_1 ang_2 pt_txt)
(setvar "CMDECHO" 0)
	(command "LAYER" "M" "SUNPOU" "")
	(setq var_txt (getvar "DIMTXT"))  ;寸法文字の大きさ
	(setq var_scal(getvar "DIMSCALE"));寸法の尺度
	(setq var_gap (getvar "DIMGAP"))  ;寸法値のギャップ
	(setq moji_taka (* var_txt var_scal))
	(setq moji_gap  (* var_gap var_scal))
;;---------------------------------------------------------
	(setq pt_1 (getpoint "\n始点を指示:"))
	(setq pt_2 (getpoint pt_1 "\n終点を指示:"))
	(command "LINE" pt_1 pt_2 "")
	(setq ang_1 (angle pt_1 pt_2))     ;ラジアン
	(setq ent_1 (entlast))
	(setq str_1 (getstring "\n寸法値を入力:"))
	(command "ERASE" ent_1 "")
;ここから作図
	(command "DIM1" "LEADER" pt_1 pt_2 "" " ")
	(command "ERASE" "L" "")
	(command "ERASE" "L" "")
;角度分岐
	(if (and (> ang_1 (* 0.5 pi)) (< ang_1 (* 1.5 pi)))
	    (progn
		(setq ang_2 (- ang_1 (* 0.5 pi)))
		(setq pt_txt(polar pt_2 ang_2 moji_gap))
		(setq ang_1 (/ (* ang_1 180.0) pi))          ;度分秒
		(setq ang_1 (+ ang_1 180.0))
		(command "TEXT" pt_txt moji_taka ang_1 str_1)
	    )
	    (progn
		(setq ang_2 (+ ang_1 (* 0.5 pi)))
		(setq pt_txt(polar pt_2 ang_2 moji_gap))
		(setq ang_1 (/ (* ang_1 180.0) pi))          ;度分秒
		(command "TEXT" "J" "R" pt_txt moji_taka ang_1 str_1)
	    )
	)
;;------------------------------------------------------------
	(command "LAYER" "S" "0" "")
(setvar "CMDECHO" 1)
(redraw)
(princ)
)
