;;************************************************************;;
;;CIVIL用ＬＳＰ                                               ;;
;;          C:LINE_KOU.lsp                                    ;;
;;                                                            ;;
;;   比例勾配と水平距離で線を描く                             ;;
;;                                                            ;;
;;                                                            ;;
;;                                        1996/04/16          ;;
;;************************************************************;;
;;;***********************
;;度--->ラジアン
(defun dtr (a)
     (* pi (/ a 180.0)))
;;;;**********************
;;ラジアン ---> 度
(defun RTD(A)
	(* 180.0(/ A PI))
)

(defun C:LINE_KOU ( / pt_st kou kou_1 dist pt pt_en)
(setvar "CMDECHO" 0)
;;値の取得------------------------------------------------------
	(setq pt_st (getpoint "\n始点を指示："))
	(if (= pt_st nil) (setq pt_st (getvar "LASTPOINT")))
	(setq kou 1.5)
	(prompt "\n勾配（比率）は [1:<") (princ kou)
	(setq kou_1 (getint ">]:"))
	(if (/= kou_1 nil)
	    (setq kou kou_1)
	)                                             ;;勾配の決定
	(setq dist (getdist pt_st "\n水平距離は？"))  ;;距離の決定
;;計算と処理-----------------------------------------------------
;;勾配は上が＋，下が－入力
;;距離は右が＋，左が－入力
;;勾配と距離の＋－で４つの方向に分れる
	(if (and (>= kou 0.0) (>= dist 0.0))
	    (progn
	         (setq pt   (polar pt_st 0 dist))
		 (setq pt_en(polar pt (dtr 90) (/ dist kou)))
 	         (command "LINE" pt_st pt_en "")
	    )
	)

	(if (and (< kou 0.0) (> dist 0.0))
	    (progn
	         (setq kou (abs kou))
	         (setq pt   (polar pt_st 0 dist))
		 (setq pt_en(polar pt (dtr 270) (/ dist kou)))
 	         (command "LINE" pt_st pt_en "")
	    )
	)

	(if (and (>= kou 0.0) (< dist 0.0))
	    (progn
	         (setq dist (abs dist))
	         (setq pt   (polar pt_st pi dist))
		 (setq pt_en(polar pt (dtr 90) (/ dist kou)))
 	         (command "LINE" pt_st pt_en "")
	    )
	)

	(if (and (< kou 0.0) (< dist 0.0))
	    (progn
	         (setq dist (abs dist))
	         (setq kou  (abs kou))
	         (setq pt   (polar pt_st pi dist))
		 (setq pt_en(polar pt (dtr 270) (/ dist kou)))
 	         (command "LINE" pt_st pt_en "")
	    )
	)
(setvar "CMDECHO" 1)
(princ)
)
